# lolautoaccept

This is a tool, that tries to automatically accept a league of legends game.
It is developed on linux and there is no effort to port it to windows.
It works by taking a screenshot every second, analysing it using opencv and clicking on `accept` using XInputSimulator.
It has problems when the champion you want to play is banned or picked by someone else. I only tested this in normals and ranked. (No Aram, Custom, URF, ....)

## Prebuilt Binary
There is a prebuild AppImage that should work on every linux x86_64 computer.
1. Download: [here](https://git.mrbesen.de/MrBesen/lolautoaccept/releases)
2. give execute rights `chmod +x LoLAutoAccept-*-x86_64.AppImage`
3. execute - dubble click or `./LoLAutoAccept-*-x86_64.AppImage`

## Dependencies
 - Qt5
 - opencv4
 - X11
 - [XInputSimulator](https://github.com/a3f/XInputSimulator.git) (is a submodule)
 - [Log](https://git.okaestne.de/okaestne/Log) (is a submodule)

## Notes
 * The Program should be able to detect the buttons no matter the client-language. But it was heavily tested with _german_.
 * The program has troubles detecting the button, when the mouse is hovering it. (Dont hover the launcher with your mouse.)
 * The launcher should be in 1280x720 (It might work with other resolutions, but they are not tested and are known to have potential problems).
 * Needs X11 and probably does not work with wayland (ubuntu). But i did not try that.

## Compile
Be sure to clone with submodules:
```
git clone --recurse-submodules https://git.mrbesen.de/MrBesen/lolautoaccept.git
```
Then in its root folder:
```
./makeXInputSimulator.sh

qmake

# build the appimage
make -j appimg

# or just the main binary
make -j
```

You can get better Logging with:
```
./lolautoaccept --debug-log
```
(This will also create a `log.txt`)
